﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GridFormatRounding
{
    public partial class Form1 : Form
    {
        int precision = 1;
        double roundingFactor = 10.0;

        public Form1()
        {
            InitializeComponent();
            roundingFactor = Math.Pow(10.0, precision);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridBand band = e.Layout.Bands[0];
            UltraGridColumn columnTruncated = band.Columns.Add("Truncated");
            columnTruncated.DataType = typeof(System.Double);

            // I used String.Format here so that columnTruncated's format would be based off the value of precision
            // If precision won't change dynamically in your application, you can use a hardcoded string instead
            columnTruncated.Format = String.Format("0.{0}", new String('0', precision));
            //columnTruncated.Format = "0.0";

            // I left both columns visible for demonstration purposes
            // Uncomment this line to hide the original column
            //band.Columns["Column 0"].Hidden = true;
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            // To truncate the number:
            // Multiply by roundingFactor to move all significant digits before the decimal
            // Use Math.Truncate to dispose of any remaining decimal value
            // Divide by roundingFactor to restore the original magnitude of the number
            e.Row.Cells["Truncated"].Value = Math.Truncate((double)e.Row.Cells["Column 0"].Value * roundingFactor) / roundingFactor;
        }
    }
}
